/**
 * Created by Administrator on 2015/4/24.
 */

var uuid = require('uuid');
var Bleach = require('bleach-client').Bleach;
var Protobuf = require('bleach-client').Protobuf;

var START = 'start';
var END = 'end';

var ActFlagType = {
    LOGIN_LOGIN: 0,
    LOGIN_GATEW: 1,
    CREATE_ROLE: 2,
    SELECT_ROLE_ONLINE: 3,
    SCENE_ENTERCOPY_C: 4,
    SCENE_EXITCOPY_C: 5,
    LOGIN_LOGIN_ALL: 6
}

var monitor = function (type, name, reqId) {
    if (typeof actor !== 'undefined') {
        actor.emit(type, name, reqId);
    } else {
        console.error(Array.prototype.slice.call(arguments, 0));
    }
}

/////////////////////////////////////////////////////////////

var ROBOT_STATE = {
    WAIT_SETTIMEOUT: 0,    //  setTimeout ʹ
    LOGIN_LOGIN_OK: 1,
    LOGIN_GATEW_OK: 2,
    CREATE_ROLE_OK: 3,
    SCENE_ENTERSCENE_OK: 4,
    SCENE_ENTERCOPY_OK: 5,

    // Error_Code_S
    EC_PLAYSTRNOTENOUGH: 100
}

var bleach = new Bleach();

bleach.connect(actor.server, function () {
    bleach.run();
});

bleach.actions.push(
    function () {
        // ERROR_CODE_S
        bleach.register(Protobuf.basetype.EProtoId.ERROR_CODE_S,
            function (message) {
                var messageErrorCode = Protobuf.errorcode.MessageErrorCode.decode(message);

                switch (messageErrorCode.code) {
                    case Protobuf.errorcode.EErrorCode.PLAYSTRNOTENOUGH:
                        bleach.customValue.STATE = ROBOT_STATE.EC_PLAYSTRNOTENOUGH;

                        break;

                    default:
                        console.log('Actor %s Error_Code_S code : %s.', actor.actorId, messageErrorCode.code.toString(16))

                }
            }
        );

        // 
        bleach.register(Protobuf.basetype.EProtoId.TICK_CMD,
            function (message) {
                bleach.request(Protobuf.basetype.EProtoId.TICK_CMD);
            }
        );
    },

    function () {
        // ֤
        bleach.request(Protobuf.basetype.EProtoId.VERIFY_VERSION,
            Protobuf.login.VerifyVersion.encode({
                clientversion: 1
            })
        );

        // ½ LoginServer ȡ
        //monitor(START, 'loginLoginAll', ActFlagType.LOGIN_LOGIN_ALL);
        monitor(START, 'loginLogin', ActFlagType.LOGIN_LOGIN);
        bleach.request(Protobuf.basetype.EProtoId.LOGIN_LOGIN_REQ,
            Protobuf.login.LoginReq.encode({
                accountid: actor.actorId
            }),
            Protobuf.basetype.EProtoId.LOGIN_LOGIN_RET,
            function (message) {
                bleach.close();

                bleach.customValue.loginRet = Protobuf.login.LoginRet.decode(message);
                bleach.connect({
                    port: bleach.customValue.loginRet.gatewayport,
                    host: bleach.customValue.loginRet.gatewayip
                }, function () {
                    monitor(END, 'loginLogin', ActFlagType.LOGIN_LOGIN);
                    bleach.customValue.STATE = ROBOT_STATE.LOGIN_LOGIN_OK;
                });
            }
        );
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.LOGIN_LOGIN_OK:
                // ½
                monitor(START, 'loginGatew', ActFlagType.LOGIN_GATEW);
                bleach.request(Protobuf.basetype.EProtoId.LOGIN_GATEW_REQ,
                    Protobuf.login.LoginGatewayReq.encode({
                        accountid: bleach.customValue.loginRet.accountid,
                        token: bleach.customValue.loginRet.token
                    }),
                    Protobuf.basetype.EProtoId.SEND_ROLE_LIST,
                    function (message) {
                        bleach.customValue.roleList = Protobuf.role.RoleList.decode(message);
                        monitor(END, 'loginGatew', ActFlagType.LOGIN_GATEW);
                        if (bleach.customValue.roleList.rolebase.length) {
                            bleach.customValue.STATE = ROBOT_STATE.LOGIN_GATEW_OK;
                        } else {
                            monitor(START, 'createRole', ActFlagType.CREATE_ROLE);
                            bleach.request(Protobuf.basetype.EProtoId.CREATE_ROLE_REQ,
                                Protobuf.role.CreateRoleReq.encode({
                                    roletype: [11103000, 11104000][Math.round(Math.random())],
                                    rolename: uuid.v1().replace(/-/g, ''),
                                    sex: 0
                                }),
                                Protobuf.basetype.EProtoId.CREATE_ROLE_RET,
                                function (message) {
                                    bleach.customValue.createRoleRet = Protobuf.role.CreateRoleRet.decode(message);
                                    monitor(END, 'createRole', ActFlagType.CREATE_ROLE);
                                    bleach.customValue.STATE = ROBOT_STATE.CREATE_ROLE_OK;
                                }
                            );
                        }
                    }
                );

                break;

            default:
                return 1;
        }
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.LOGIN_GATEW_OK:
                // ѡǵ½
                monitor(START, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                bleach.request(Protobuf.basetype.EProtoId.SELECT_ROLE_ONLINE,
                    Protobuf.role.SelectRoleOnline.encode({
                        roleid: bleach.customValue.roleList.rolebase[0].roleid
                    }),
                    Protobuf.basetype.EProtoId.SCENE_ENTERSCENE_S,
                    function (message) {
                        monitor(END, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                        //monitor(END, 'loginLoginAll', ActFlagType.LOGIN_LOGIN_ALL);
                        bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                    }
                );

                break;

            case ROBOT_STATE.CREATE_ROLE_OK:
                // ѡǵ½
                monitor(START, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                bleach.request(Protobuf.basetype.EProtoId.SELECT_ROLE_ONLINE,
                    Protobuf.role.SelectRoleOnline.encode({
                        roleid: bleach.customValue.createRoleRet.rolebase.roleid
                    }),
                    Protobuf.basetype.EProtoId.SCENE_ENTERSCENE_S,
                    function (message) {
                        monitor(END, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                        //monitor(END, 'loginLoginAll', ActFlagType.LOGIN_LOGIN_ALL);
                        bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                    }
                );

                break;

            default:
                return 1;
        }
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.SCENE_ENTERSCENE_OK:
                console.log('SCENE_ENTERSCENE_OK')
                bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                setInterval(function () {
                }, bleach.responseOverTime);

                break;

            default:
                return 1;
        }
    }
)