/**
 * Created by Administrator on 2015/4/24.
 */

var uuid = require('uuid');
var Bleach = require('bleach-client').Bleach;
var Protobuf = require('bleach-client').Protobuf;

var START = 'start';
var END = 'end';

var ActFlagType = {
    LOGIN_LOGIN: 0,
    LOGIN_GATEW: 1,
    CREATE_ROLE: 2,
    SELECT_ROLE_ONLINE: 3,
    SCENE_ENTERCOPY_C: 4,
    SCENE_EXITCOPY_C: 5,
    LOGIN_LOGIN_ALL: 6
}

var monitor = function (type, name, reqId) {
    if (typeof actor !== 'undefined') {
        actor.emit(type, name, reqId);
    } else {
        console.error(Array.prototype.slice.call(arguments, 0));
    }
}

/////////////////////////////////////////////////////////////

var ROBOT_STATE = {
    WAIT_SETTIMEOUT: 0,    //  setTimeout ʹ
    LOGIN_LOGIN_OK: 1,
    LOGIN_GATEW_OK: 2,
    CREATE_ROLE_OK: 3,
    SCENE_ENTERSCENE_OK: 4,
    SCENE_ENTERCOPY_OK: 5,

    // Error_Code_S
    EC_PLAYSTRNOTENOUGH: 100
}

var bleach = new Bleach();

bleach.connect(actor.server, function () {
    bleach.run();
});

bleach.actions.push(
    function () {
        // ERROR_CODE_S
        bleach.register(Protobuf.basetype.EProtoId.ERROR_CODE_S,
            function (message) {
                var messageErrorCode = Protobuf.errorcode.MessageErrorCode.decode(message);

                switch (messageErrorCode.code) {
                    case Protobuf.errorcode.EErrorCode.PLAYSTRNOTENOUGH:
                        bleach.customValue.STATE = ROBOT_STATE.EC_PLAYSTRNOTENOUGH;

                        break;

                    default:
                        console.log('Error_Code_S code : %s.', messageErrorCode.code.toString(16));
                }
            }
        );

        // 
        bleach.register(Protobuf.basetype.EProtoId.TICK_CMD,
            function (message) {
                bleach.request(Protobuf.basetype.EProtoId.TICK_CMD);
            }
        );
    },

    function () {
        // ֤
        bleach.request(Protobuf.basetype.EProtoId.VERIFY_VERSION,
            Protobuf.login.VerifyVersion.encode({
                clientversion: 1
            })
        );

        // ½ LoginServer ȡ
        monitor(START, 'loginLogin', ActFlagType.LOGIN_LOGIN);
        bleach.request(Protobuf.basetype.EProtoId.LOGIN_LOGIN_REQ,
            Protobuf.login.LoginReq.encode({
                accountid: actor.actorId
            }),
            Protobuf.basetype.EProtoId.LOGIN_LOGIN_RET,
            function (message) {
                bleach.close();

                bleach.customValue.loginRet = Protobuf.login.LoginRet.decode(message);
                bleach.connect({
                    port: bleach.customValue.loginRet.gatewayport,
                    host: bleach.customValue.loginRet.gatewayip
                }, function () {
                    monitor(END, 'loginLogin', ActFlagType.LOGIN_LOGIN);
                    bleach.customValue.STATE = ROBOT_STATE.LOGIN_LOGIN_OK;
                });
            }
        );
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.LOGIN_LOGIN_OK:
                // ½
                monitor(START, 'loginGatew', ActFlagType.LOGIN_GATEW);
                bleach.request(Protobuf.basetype.EProtoId.LOGIN_GATEW_REQ,
                    Protobuf.login.LoginGatewayReq.encode({
                        accountid: bleach.customValue.loginRet.accountid,
                        token: bleach.customValue.loginRet.token
                    }),
                    Protobuf.basetype.EProtoId.SEND_ROLE_LIST,
                    function (message) {
                        bleach.customValue.roleList = Protobuf.role.RoleList.decode(message);

                        if (bleach.customValue.roleList.rolebase.length) {
                            monitor(END, 'loginGatew', ActFlagType.LOGIN_GATEW);
                            bleach.customValue.STATE = ROBOT_STATE.LOGIN_GATEW_OK;
                        } else {
                            monitor(START, 'createRole', ActFlagType.CREATE_ROLE);
                            bleach.request(Protobuf.basetype.EProtoId.CREATE_ROLE_REQ,
                                Protobuf.role.CreateRoleReq.encode({
                                    roletype: [11103000, 11104000][Math.round(Math.random())],
                                    rolename: uuid.v1().replace(/-/g, ''),
                                    sex: 0
                                }),
                                Protobuf.basetype.EProtoId.CREATE_ROLE_RET,
                                function (message) {
                                    bleach.customValue.createRoleRet = Protobuf.role.CreateRoleRet.decode(message);
                                    monitor(END, 'createRole', ActFlagType.CREATE_ROLE);
                                    bleach.customValue.STATE = ROBOT_STATE.CREATE_ROLE_OK;
                                }
                            );
                        }
                    }
                );

                break;

            default:
                return 1;
        }
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.LOGIN_GATEW_OK:
                // ѡǵ½
                monitor(START, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                bleach.request(Protobuf.basetype.EProtoId.SELECT_ROLE_ONLINE,
                    Protobuf.role.SelectRoleOnline.encode({
                        roleid: bleach.customValue.roleList.rolebase[0].roleid
                    }),
                    Protobuf.basetype.EProtoId.SCENE_ENTERSCENE_S,
                    function (message) {
                        if (bleach.customValue.STATE == ROBOT_STATE.LOGIN_GATEW_OK) {
                            monitor(END, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                        } else {
                            monitor(END, 'sceneExitcopyC', ActFlagType.SCENE_EXITCOPY_C);
                        }
                        bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                    }
                );

                break;

            case ROBOT_STATE.CREATE_ROLE_OK:
                // ѡǵ½
                monitor(START, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                bleach.request(Protobuf.basetype.EProtoId.SELECT_ROLE_ONLINE,
                    Protobuf.role.SelectRoleOnline.encode({
                        roleid: bleach.customValue.createRoleRet.rolebase.roleid
                    }),
                    Protobuf.basetype.EProtoId.SCENE_ENTERSCENE_S,
                    function (message) {
                        if (bleach.customValue.STATE == ROBOT_STATE.CREATE_ROLE_OK) {
                            monitor(END, 'selectRoleOnline', ActFlagType.SELECT_ROLE_ONLINE);
                        } else {
                            monitor(END, 'sceneExitcopyC', ActFlagType.SCENE_EXITCOPY_C);
                        }
                        bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                    }
                );

                break;

            default:
                return 1;
        }
    },

    function () {
        switch (bleach.customValue.STATE) {
            case ROBOT_STATE.SCENE_ENTERSCENE_OK:
                // 븱
                bleach.customValue.STATE = ROBOT_STATE.WAIT_SETTIMEOUT;
                setTimeout(function () {
                    monitor('incr', 'sceneEntercopyC');
                    monitor(START, 'sceneEntercopyC', ActFlagType.SCENE_ENTERCOPY_C);
                    bleach.request(Protobuf.basetype.EProtoId.SCENE_ENTERCOPY_C,
                        Protobuf.scene.MessageEnterCopy.encode({
                            copyid: 14100002
                        }),
                        Protobuf.basetype.EProtoId.SCENE_ENTERCOPY_S,
                        function (message) {
                            monitor(END, 'sceneEntercopyC', ActFlagType.SCENE_ENTERCOPY_C);
                            bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERCOPY_OK;
                        }
                    );
                }, bleach.getThinkTime());

                //return 1;
                break;

            case ROBOT_STATE.SCENE_ENTERCOPY_OK:
                // ˳
                bleach.customValue.STATE = ROBOT_STATE.WAIT_SETTIMEOUT;
                setTimeout(function () {
                    monitor('incr', 'sceneExitcopyC');
                    monitor(START, 'sceneExitcopyC', ActFlagType.SCENE_EXITCOPY_C);
                    bleach.request(Protobuf.basetype.EProtoId.SCENE_EXITCOPY_C,
                        Protobuf.scene.MessageExitCopy.encode({})
                    );
                }, bleach.getThinkTime());

                break;

            case ROBOT_STATE.EC_PLAYSTRNOTENOUGH:
                // 㣬
                bleach.request(Protobuf.basetype.EProtoId.CHAT_PRIVATE_REQ,
                    Protobuf.chat.ChatPrivateReq.encode({
                        roleid: 0,
                        text: '//strength num=50000000'
                    }),
                    Protobuf.basetype.EProtoId.ROLE_ATTRCHANGES_S,
                    function (message) {
                        if (bleach.customValue.STATE == ROBOT_STATE.EC_PLAYSTRNOTENOUGH) {
                            var roleAttrChange = Protobuf.role.RoleAttrChange.decode(message);
                            for (var attr in roleAttrChange.changelist) {
                                if (attr.key == Protobuf.roletype.RoleAttr.eRoleAttr_Strength) {
                                    bleach.customValue.STATE = ROBOT_STATE.SCENE_ENTERSCENE_OK;
                                }
                            }

                        }
                    }
                );

            default:
                return 1;
        }

        return 1;
    },

    function () {
        setTimeout(function () {
            bleach.close();
        }, bleach.responseOverTime);
    }
)

//bleach.run()